

// Initialize app
var myApp = new Framework7({
    pushState: true,
    swipePanel: 'left',
    materialPageLoadDelay:60,
    
    // ... other parameters
});

var apiKey = "https://api.ottnec.de/";
//var apiKey = "http://192.168.0.101/p/api/";
// If we need to use custom DOM library, let's save it to $$ variable:
var $$ = Dom7;

// Add view
var mainView = myApp.addView('.view-main', {
    // Because we want to use dynamic navbar, we need to enable it for this view:
    dynamicNavbar: false
});

// Handle Cordova Device Ready Event
$$(document).on('deviceready', function() {
    console.log("Device is ready!");
});

$$(document).on('click', '#addKey', function (e){
    var objData = $$('#addKey').data('test');
     $$.post(apiKey + 'kunde/tsApi.php', {push: "create_key", ts_ip: objData.ts_ip, ts_id: objData.ts_id}, function (data) {
            mainView.router.refreshPage();
        });

 });

$$(document).on('click', '#actionClient', function (e){
    var clientId = $$(this).data("id");
    var buttons = [
        {
            text: 'Folgende Optionen stehen zur Auswahl',
            label: true
        },
        {
            text: 'Kick',
            onClick: function(){
                mainView.alert("Diese Funktion folgt in kürze!", "Ottnec-Benachrichtigung");
            }
        },
        {
            text: 'Ban',
            onClick: function(){
                mainView.alert("Diese Funktion folgt in kürze!", "Ottnec-Benachrichtigung");

            }
        },
        {
            text: 'Anstupsen',
            onClick: function(){
                mainView.alert("Diese Funktion folgt in kürze!", "Ottnec-Benachrichtigung");
            }
        },
        {
            text: 'Nachricht schreiben',
            onClick: function(){
                mainView.alert("Diese Funktion folgt in kürze!", "Ottnec-Benachrichtigung");
        }
        },
        {
            text: 'Abbrechen',
            color: 'red'
        },
    ];
    myApp.actions(buttons);
 });

$$(document).on('click', '#addBackup', function (e){
    var objData = $$('#backup_list').data('test');
     $$.post(apiKey + 'kunde/tsApi.php', {push: "add_backup", ts_ip: objData.ts_ip, ts_id: objData.ts_id}, function (data) {
            mainView.router.refreshPage();
        });

 });

$$(document).on('change', "#onlineCheck", function (e) {
    var isChecked = $$('#onlineCheck').prop('checked');
    var objData = $$('#onlineCheck').data('test');
    //alert(objData.ts_id);
    //alert(isChecked);

    $$.post(apiKey + 'kunde/tsApi.php', {push: "change_online", new_stat: isChecked, ts_ip: objData.ts_ip, ts_id: objData.ts_id}, function (data) {
        
    });
});

//$$(document).on('backbutton', mainView.router.back(), true);

// Now we need to run the code that will be executed only for About page.

// Option 1. Using page callback for page (for "about" page in this case) (recommended way):
myApp.onPageInit('tsAdmin', function (page) {
    // Do something here for "about" page
    var ts_id = page.query.tsid;
    var ts_ip = page.query.tsip;

    var content = "<ul><li><a href='src/ts/start.html?tsid="+ts_id+"&tsip="+ts_ip+"' class='item-link list-button'>Start/Stop</a></li>";
    content += "<li><a href='src/ts/bkey.html?tsid="+ts_id+"&tsip="+ts_ip+"' class='item-link list-button'>Berechtigungsschlüssel</a></li>";
    content += "<li><a href='src/ts/backup.html?tsid="+ts_id+"&tsip="+ts_ip+"' class='item-link list-button'>Backup</a></li>";
    content += "<li><a href='src/ts/clients.html?tsid="+ts_id+"&tsip="+ts_ip+"' class='item-link list-button'>Verbundene Clienten</a></li>";
    content += "</ul>";
    $$('.tsAdmin').html(content);
});

myApp.onPageInit('backup', function (page) {
    setHeader();
    var ts_id = page.query.tsid;
    var ts_ip = page.query.tsip;
    myApp.showPreloader('Lade Daten');

    $$("#backup_list").data('test',{"ts_id":ts_id, "ts_ip":ts_ip});

    $$.post(apiKey + 'kunde/tsApi.php', {fetch: "get_backups", ts_ip: ts_ip, ts_id: ts_id}, function (data) {
        var obj = JSON.parse(data);
        var content = "";
        for(var i=0; i < obj.length; i++){
            content += '<li class="swipeout"><div class="swipeout-content item-content"><div class="item-inner"><div class="item-title">Backup Id: '+obj[i].id+'</div><div class="item-after">'+obj[i].date+'</div></div></div><div class="swipeout-actions-right">';
            content += '<a href="javascript:deployBackup('+obj[i].id+')" class="deployBackup">Backup aufspielen</a></div></li>';
        }
        $$('#backup_list').html(content);
        myApp.hidePreloader();
     });

});

myApp.onPageAfterAnimation('clients', function (page) {
    setHeader();
    var ts_id = page.query.tsid;
    var ts_ip = page.query.tsip;
    myApp.showPreloader('Lade Daten');

    $$("#clientContent").data('test',{"ts_id":ts_id, "ts_ip":ts_ip});

    $$.post(apiKey + 'kunde/tsApi.php', {fetch: "get_clients", ts_ip: ts_ip, ts_id: ts_id}, function (data) {
        var obj = JSON.parse(data);
        var content = "";
        for(var i=0; i < obj.length; i++){
            content += '<li><a id="actionClient" href="#" class="item-link list-button" data-id="'+obj[i].id+'">'+obj[i].name+'</a></li>';
        }
        $$('#clientContent').html(content);
        myApp.hidePreloader();
     });

});


myApp.onPageInit('bkey', function (page) {
    setHeader();
    // Do something here for "about" page
    var ts_id = page.query.tsid;
    var ts_ip = page.query.tsip;
    myApp.showPreloader('Lade Daten');

    $$("#addKey").data('test',{"ts_id":ts_id, "ts_ip":ts_ip});

    //alert (ts_id+" "+ts_ip);
    //alert(localStorage.getItem("apiKey"));
    $$.post(apiKey + 'kunde/tsApi.php', {fetch: "get_b_key", ts_ip: ts_ip, ts_id: ts_id}, function (data) {
        var obj = JSON.parse(data);
        var content = "";
        for(var i = 0; i<obj.length ; i++){
            content += '<li class="item-content"><div class="item-inner"><div class="item-title">'+obj[i].token+'</div><div class="item-after">'+obj[i].group+'</div></div></li>';
        }
        //content += "</ul></div>";
        $$(".bkey_content").html(content);
        myApp.hidePreloader();
    });

   
});

myApp.onPageAfterAnimation('start', function (page) {
    // Do something here for "about" page
    var ts_id = page.query.tsid;
    var ts_ip = page.query.tsip;
    myApp.showPreloader('Lade Daten');

    $$("#onlineCheck").data('test',{"ts_id":ts_id, "ts_ip":ts_ip});

    
    $$.post(apiKey + 'kunde/tsApi.php', {fetch: "get_ts_online", ts_ip: ts_ip, ts_id: ts_id}, function (data) {
        if(data == "1"){
            $$('#onlineCheck').prop('checked', true);
        }
        myApp.hidePreloader();
    });
});

myApp.onPageAfterAnimation('ts', function (page) {
    myApp.showPreloader('Lade Daten');
    if(checkLogin() == false){
        var content = "<div class='content-block'><h4>Um diesen Dienst nutzen zu können, müssen Sie sich anmelden.</h4>";
        content += '<br><br><a href="#" class="button button-big open-login-screen">Anmelden</a></div>';
        $$(page.container).find('.content-block').append(content);
        myApp.hidePreloader();
    } else{
        initTSpage();
        myApp.hidePreloader();
    }
});

// Option 2. Using one 'pageInit' event handler for all pages:




// Option 2. Using live 'pageInit' event handlers for each page


$$('.panel-close').on('click', function (e) {
        myApp.closePanel();
    });





//Check ob schon eingeloggt.
function checkLogin(){
    //localStorage.clear();
    var key = localStorage.getItem("apiKey");
    if(key == null){
        return false;
    } else{
        setHeader();
        return true;
    }
}

function setHeader(){
    var key = localStorage.getItem("apiKey");
    $$.ajaxSetup({
            headers: {
                'apiKey': key
            }
        });
}

function login(){
    var pass = $$('#loginPass').val();
    var user = $$('#loginUser').val();
    myApp.showPreloader('Lade Daten');
    $$.post(apiKey + 'kunde/login.php', {username: user, pass: pass}, function (data) {
        myApp.hidePreloader();
          if(data != "false"){
            apiKey = data;
            localStorage.setItem("apiKey", data);
            myApp.alert("Sie sind nun eingeloggt", "Ottnec-Benachrichtigung");
            $$.ajaxSetup({
            headers: {
                'apiKey': data
            }
            });
            mainView.router.refreshPage();
            myApp.closeModal(loginScreen, animated);
          } else{
            myApp.alert("Irgendwas stimmt mit den Logindaten nicht.", "Ottnec-Benachrichtigung");
          }
    });

}

function logout(){
    localStorage.clear();
    myApp.alert("Sie sind nun Abgemeldet.","Ottnec-Benachrichtigung");
}

function deployBackup(backupId){
    var buttons = [
        {
            text: 'Dieses Backup unwiederuflich aufspielen?',
            label: true
        },
        {
            text: 'Ja',
            bold: true,
            onClick: function(){
                var obj =  $$("#backup_list").data('test');
                //(obj.ts_ip+" "+obj.ts_id);
                $$.post(apiKey + 'kunde/tsApi.php', {push: "deploy_backup", ts_ip: obj.ts_ip, ts_id: obj.ts_id, backup_id: backupId}, function (data) {
                    mainView.alert("Das Backup wurde aufgespielt und der Server wurde neugestartet");
                });
            }
        },
        {
            text: 'Abbrechen',
            color: 'red'
        },
    ];
    myApp.actions(buttons);
}



//init
function initTSpage(){
    $$.post(apiKey + 'kunde/tsApi.php', {fetch: "get_all_server"}, function (data) {
        var obj = JSON.parse(data);
        var content = "<div class='list-block'><div class='list-block-label'>Folgende TS-Server haben wir in unserem System gefunden</div><ul>";
        for(var i=0; i<obj.length; i++){
            content += "<li><a href='src/ts/tsAdmin.html?tsid="+obj[i].ts_id+"&tsip="+obj[i].ip_host+"' class='item-link list-button'>"+obj[i].ip_host+":"+obj[i].port+"</a></li>";
        }
        content += "</ul></div>";
        $$('.tsContainer').html(content);
    });
    
}

function sendClientMessage(clientId){
    myApp.prompt('Schreibe deine Nachricht', 'Nachricht schreiben', function (value) {
        $$.post(apiKey + 'kunde/tsApi.php', {push: "add_client", ts_ip: obj.ts_ip, ts_id: obj.ts_id, client_action: "message", client_id: clientId, client_message: value}, function (data) {
            mainView.alert("Nachricht wurde gesendet", "Ottnec-Benachrichtigung");
        });
    });
}

//Ab Hier Domain

myApp.onPageInit('domain', function (page) {
    // Do something here for "about" page
    if(checkLogin() == false){
        var content = "<div class='content-block'><h4>Um diesen Dienst nutzen zu können, müssen Sie sich anmelden.</h4>";
        content += '<br><br><a href="#" class="button button-big open-login-screen">Anmelden</a></div>';
        $$(page.container).find('.content-block').append(content);
    } else{
        setHeader();
        myApp.showPreloader('Lade Daten');
        $$.post(apiKey + 'kunde/domain.php', {fetch: "get_domains"}, function (data) {
            var domains = JSON.parse(data);
            var content = "";
            var date = new Date()
            for(var i=0; i<domains.length; i++){
                content += '<li><a href="src/domainSite.html?domain='+domains[i].domain+'" class="item-link item-content"><div class="item-media"><img src="img/world-wide-web.svg" style="width:1em;"/></div><div class="item-inner">';
                content += '<div class="item-title">'+domains[i].domain+'</div><div class="item-after">'+domains[i].start_date.date.substr(0,10)+'</div></div></a></li>';
            }
            $$('.domainContent').html(content);
            myApp.hidePreloader();
        });
    }

});

myApp.onPageInit('domainSite', function (page) {
    // Do something here for "about" page
    setHeader();
    var domain = page.query.domain;
    myApp.showPreloader('Lade Daten');
    $$.post(apiKey + 'kunde/domain.php', {fetch: "get_domain_records", domain_name: domain}, function (data) {
        var records = JSON.parse(data);
        var content = "";
        for(var i=0; i < records.length; i++){
            content += '<li class="item-content"><div class="item-media">'+records[i].fieldType+'</div><div class="item-inner">';
            content += '<div class="item-title">'+records[i].subDomain+'</div><div class="item-after">'+records[i].target+'</div></div></li>';
        }
        $$('.domainSiteContent').html(content);
        myApp.hidePreloader();
    });

});


//Accounting


myApp.onPageInit('account', function (page) {
    // Do something here for "about" page
    setHeader();
    var subsite = page.query.subsite;
    //myApp.showPreloader('Lade Daten');
    //alert(subsite);
    myApp.showPreloader('Lade Daten');

    $$.post(apiKey + 'kunde/accounting.php', {fetch: "get_account_info"}, function (data) {
        var user = JSON.parse(data);
        var content = "<div class='content-block-title'><h3>Deine hinterlegten Account-Daten:</h3></div><div class='list-block'><ul>";
        content += '<div class="item-content"><div class="item-inner"><div class="item-title">Vorname</div><div class="item-after">'+user.firstname+'</div></div></div></li>';
        content += '<div class="item-content"><div class="item-inner"><div class="item-title">Nachname</div><div class="item-after">'+user.lastname+'</div></div></div></li>';
        content += '<div class="item-content"><div class="item-inner"><div class="item-title">Email</div><div class="item-after">'+user.email+'</div></div></div></li>';
        content += '</ul></div>';
        $$('.content_account').html(content);
        $$('#account_info').addClass("active");
        myApp.hidePreloader();
    });
});

$$(document).on("click","#bill_button", function(e){
    myApp.showPreloader('Lade Daten');
    $$.post(apiKey + 'kunde/accounting.php', {fetch: "get_user_bills"}, function (data) {
            //alert(data);
            var bills = JSON.parse(data);
            //alert(bills[0].date);
            var content = "<div class='content-block-title'><h3>Gestellte Rechnungen:</h3></div><div class='list-block'><ul>";
            var content2 = "";
            for(var i = 0; i < bills.length; i++){
                if(bills[i].paid == "0"){
                    content += '<li class="item-content"><div class="item-media"><img src="img/bill_red.png" style="width:1em;"/></div><div class="item-inner">';
                    content += '<div class="item-title">'+bills[i].date+'</div><div class="item-after">Zahlung ausstehend</div></div></li>';
                } else{
                    content2 += '<li class="item-content"><div class="item-media"><img src="img/bill_green.png" style="width:1em;"/></div><div class="item-inner">';
                    content2 += '<div class="item-title">'+bills[i].date+'</div><div class="item-after">'+bills[i].method+'</div></div></li>';
                }
            }
            content += content2 + "</ul></div>";
            $$('.content_account').html(content);
            $$('#bill_button').removeClass("active");
            $$('#bill_button').addClass("active");

            myApp.hidePreloader();
        });
});

$$(document).on("click","#account_info", function(e){
    setHeader();
    //myApp.showPreloader('Lade Daten');
    //alert(subsite);
    myApp.showPreloader('Lade Daten');

    $$.post(apiKey + 'kunde/accounting.php', {fetch: "get_account_info"}, function (data) {
        var user = JSON.parse(data);
        var content = "<div class='content-block-title'><h3>Deine hinterlegten Account-Daten:</h3></div><div class='list-block'><ul>";
        content += '<div class="item-content"><div class="item-inner"><div class="item-title">Vorname</div><div class="item-after">'+user.firstname+'</div></div></div></li>';
        content += '<div class="item-content"><div class="item-inner"><div class="item-title">Nachname</div><div class="item-after">'+user.lastname+'</div></div></div></li>';
        content += '<div class="item-content"><div class="item-inner"><div class="item-title">Email</div><div class="item-after">'+user.email+'</div></div></div></li>';
        content += '</ul></div>';
        $$('.content_account').html(content);
        $$('#account_info').addClass("active");
        myApp.hidePreloader();
    });
});